<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Symbol Features</TITLE>
<link href="suif1_53.html" rel=Next>
<link href="suif1_51.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_51.html">previous</A>, <A HREF="suif1_53.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC52" HREF="suif1_toc.html#TOC52">Basic Features of Symbols</A></H2>

<P>
<A NAME="IDX336"></A>
<A NAME="IDX337"></A>
The <CODE>sym_node</CODE> class defines several fields that are used by all
kinds of symbols.  The most obvious of these is the symbol name.  Each
symbol has a name that should be unique within the symbol table where it
is defined.  The <CODE>name</CODE> and <CODE>set_name</CODE> methods access this
field.  The names are automatically entered in the lexicon
(see section <A HREF="suif1_102.html#SEC102">Lexicon</A>) by <CODE>set_name</CODE>.  Because the name of a symbol
alone is generally insufficient to uniquely identify it, the symbols are
also given ID numbers.  See section <A HREF="suif1_50.html#SEC50">Numbering Types and Symbols</A>.

</P>
<P>
<A NAME="IDX338"></A>
When a symbol is entered in a symbol table, it automatically records a
pointer to that parent table.  Similarly, when the symbol is removed
from the symbol table, its parent pointer is cleared.  The <CODE>parent</CODE>
method retrieves this parent pointer.

</P>
<P>
<A NAME="IDX339"></A>
<A NAME="IDX340"></A>
<A NAME="IDX341"></A>
All symbols contain flags to specify various attributes.  The
<CODE>sym_node</CODE> class provides methods to access these flags.  The
<CODE>is_userdef</CODE> method tests a flag to see if it is a user-defined
symbol (from the source code) or a new symbol introduced by the
compiler.  The <CODE>set_userdef</CODE> and <CODE>reset_userdef</CODE> methods
change the value of this flag.

</P>
<P>
<A NAME="IDX342"></A>
Another flag is used to mark symbols that are only declarations of
external symbols, rather than actual definitions.  This flag is set
automatically.  The <CODE>is_extern</CODE> method retrieves its value.  Label
symbols are never <CODE>extern</CODE>.  A procedure symbol is <CODE>extern</CODE>
unless the procedure body is defined in the input file(s).  A global
variable symbol is <CODE>extern</CODE> unless it has a separate definition
(see section <A HREF="suif1_58.html#SEC58">Variable Definitions</A>); no other variables are <CODE>extern</CODE>.

</P>
<P>
<A NAME="IDX343"></A>
<A NAME="IDX344"></A>
Since symbols may be treated differently depending on their scopes, the
<CODE>sym_node</CODE> class includes methods to determine which kind of symbol
table contains a symbol.  The <CODE>is_global</CODE> method checks if the
parent table is a global or file symbol table.  This is really only
useful for variable symbols, because procedures are always global and
labels are never global.  The <CODE>is_private</CODE> method checks if a
symbol is global but private to one source file by checking if the
parent symbol table is a file symbol table.  This is obviously
irrelevant for label symbols.

</P>
<P>
<A NAME="IDX345"></A>
<A NAME="IDX346"></A>
The <CODE>add_to_table</CODE> and <CODE>remove_from_table</CODE> methods are
provided for convenience when adding or removing symbols from symbol
tables.  In the case of variable symbols, the entire hierarchy of
sub-variables (see section <A HREF="suif1_57.html#SEC57">Sub-Variables</A>) is added or removed at one time
by this method.

</P>
<P>
<A NAME="IDX347"></A>
The <CODE>copy</CODE> method makes a copy of a symbol.  This is a virtual
function so it copies the fields that are specific to each kind of
symbol.  However, it only copies the symbol itself: copying a procedure
symbol will not copy the procedure body and copying a variable symbol
will not copy the variable definition.  The <CODE>copy</CODE> method does not
copy annotations on the symbol, either.  Since the copy will have the
same name as the original symbol, it should generally be renamed or used
in a different symbol table.

</P>
<P>
<A NAME="IDX348"></A>
<A NAME="IDX349"></A>
Two different methods are available for printing symbols.  The
<CODE>print</CODE> method just prints the name of the symbol.  Label symbols
are prefixed by <SAMP>`L:'</SAMP> and procedure symbols by <SAMP>`P:'</SAMP> to
distinguish them from variable symbols.  The <CODE>print_full</CODE> method is
used by the library when listing the contents of symbol tables.  It
includes all the fields from the <CODE>sym_node</CODE>.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_51.html">previous</A>, <A HREF="suif1_53.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
